/*
 * ------------------------------------------------------------------------
 *
 *  Copyright (C) 2003 - 2013
 *  University of Konstanz, Germany and
 *  KNIME GmbH, Konstanz, Germany
 *  Website: http://www.knime.org; Email: contact@knime.org
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License, Version 3, as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, see <http://www.gnu.org/licenses>.
 *
 *  Additional permission under GNU GPL version 3 section 7:
 *
 *  KNIME interoperates with ECLIPSE solely via ECLIPSE's plug-in APIs.
 *  Hence, KNIME and ECLIPSE are both independent programs and are not
 *  derived from each other. Should, however, the interpretation of the
 *  GNU GPL Version 3 ("License") under any applicable laws result in
 *  KNIME and ECLIPSE being a combined program, KNIME GMBH herewith grants
 *  you the additional permission to use and propagate KNIME together with
 *  ECLIPSE with only the license terms in place for ECLIPSE applying to
 *  ECLIPSE and the GNU GPL Version 3 applying for KNIME, provided the
 *  license terms of ECLIPSE themselves allow for the respective use and
 *  propagation of ECLIPSE together with KNIME.
 *
 *  Additional permission relating to nodes for KNIME that extend the Node
 *  Extension (and in particular that are based on subclasses of NodeModel,
 *  NodeDialog, and NodeView) and that only interoperate with KNIME through
 *  standard APIs ("Nodes"):
 *  Nodes are deemed to be separate and independent programs and to not be
 *  covered works.  Notwithstanding anything to the contrary in the
 *  License, the License does not apply to Nodes, you are not required to
 *  license Nodes under the License, and you are granted a license to
 *  prepare and propagate Nodes, in each case even if such Nodes are
 *  propagated with or for interoperation with KNIME.  The owner of a Node
 *  may freely choose the license terms applicable to such Node, including
 *  when such Node is propagated with or for interoperation with KNIME.
 * ---------------------------------------------------------------------
 *
 * Created on 12.04.2013 by koetter
 */
package edu.cmu.koetter.conceptgraph;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.knime.core.data.DataValue;
import org.knime.core.node.defaultnodesettings.DefaultNodeSettingsPane;
import org.knime.core.node.defaultnodesettings.DialogComponentBoolean;
import org.knime.core.node.defaultnodesettings.DialogComponentColumnNameSelection;
import org.knime.core.node.defaultnodesettings.DialogComponentNumber;
import org.knime.core.node.defaultnodesettings.SettingsModelBoolean;
import org.knime.network.core.knime.node.AbstractGraphNodeModel;

/**
 *
 * @author koetter
 */
public class ConceptGraphExtractorNodeDialog extends DefaultNodeSettingsPane {
    /**
     *
     */
    @SuppressWarnings("unchecked")
    public ConceptGraphExtractorNodeDialog() {
//        addDialogComponent(new DialogComponentButtonGroup(ConceptGraphExtractorNodeModel.createTypeModel(),
//                                                          "Extractor: ", false, ConceptGraphExtractorType.values()));
//        addDialogComponent(new DialogComponentButtonGroup(ConceptGraphExtractorNodeModel.createScoreModel(),
//                                                          "Score: ", false, ConceptGraphScore.values()));
        addDialogComponent(new DialogComponentColumnNameSelection(
                  ConceptGraphExtractorNodeModel.createObjectIdColumnModel(), "Object id column:", 1, DataValue.class));
        final SettingsModelBoolean addGraphCell = ConceptGraphExtractorNodeModel.createAddGraphCellsModel();
        final SettingsModelBoolean cacheGraphCell = AbstractGraphNodeModel.createCacheGraphCellModel();
        addGraphCell.addChangeListener(new ChangeListener() {
            @Override
            public void stateChanged(final ChangeEvent e) {
                cacheGraphCell.setEnabled(addGraphCell.getBooleanValue());
            }
        });
        addDialogComponent(new DialogComponentBoolean(addGraphCell, "Add concept graph cells"));
        addDialogComponent(new DialogComponentBoolean(cacheGraphCell, "Cache concept graph cells"));
        addDialogComponent(new DialogComponentNumber(
                             ConceptGraphExtractorNodeModel.createNoOfProcessesModel(), "No of parallel processes", 1));
//        addDialogComponent(new DialogComponentNumber(
//                             ConceptGraphExtractorNodeModel.createCueValidityModel(), "Cue validity exponent", 1));
//        addDialogComponent(new DialogComponentNumber(
//                             ConceptGraphExtractorNodeModel.createDensityModel(), "Density exponent", 1));
//        addDialogComponent(new DialogComponentNumber(
//                             ConceptGraphExtractorNodeModel.createSizeModel(), "Size exponent", 1));
        addDialogComponent(new DialogComponentNumber(
                             ConceptGraphExtractorNodeModel.createMinNodeDegreeModel(), "Minimum node degree", 1));
    }
}
